Components.utils.import("resource:///modules/gloda/mimemsg.js");

var gStripAttachments = {

	init : function() {
		var mailSession = Components.classes["@mozilla.org/messenger/services/session;1"]
			.getService(Components.interfaces.nsIMsgMailSession);
		var nsIFolderListener = Components.interfaces.nsIFolderListener;
		var notifyFlags = nsIFolderListener.added;
		mailSession.AddFolderListener(gStripAttachments.folderListener, notifyFlags);
		gStripAttachments.resetCheckbox();
		window.addEventListener("compose-send-message", gStripAttachments.onSend, true ); 
		window.addEventListener("compose-window-reopen", gStripAttachments.resetCheckbox, true);
	},

	resetCheckbox : function() {
		document.getElementById("AETdeleteOnSend").checked = false;
	},

	onSend : function(evt) {
		var attachmentBucket = document.getElementById("attachmentBucket");
		var msg_type = document.getElementById("msgcomposeWindow").getAttribute("msgtype"); 
		if (! document.getElementById("AETdeleteOnSend").checked || ! attachmentBucket .hasChildNodes() || msg_type != 0) {
			gStripAttachments.folderListener.abort = true;
			return;
		}
		gStripAttachments.folderListener.abort = false;
		gStripAttachments.folderListener.id  = null;		
		/*var identity =  getCurrentIdentity();
		if (identity.doFcc)
			gStripAttachments.folderListener.originalFcc0 = identity.fccFolder;
		else
			gStripAttachments.folderListener.originalFcc0 = "";
		if (typeof gMsgCompose.compFields.fcc != "undefined")
			gStripAttachments.folderListener.originalFcc1 = gMsgCompose.compFields.fcc;
		else
			gStripAttachments.folderListener.originalFcc1 = "";
		if (typeof gMsgCompose.compFields.fcc2 != "undefined")
			gStripAttachments.folderListener.originalFcc2 = gMsgCompose.compFields.fcc2;
		else
			gStripAttachments.folderListener.originalFcc2 = "";*/
		gMsgCompose.addMsgSendListener(gStripAttachments.sendListener);
		if (gMsgCompose.compFields.otherRandomHeaders) {
			var newH = "X-Strip_Attachments: true\r\n";
			gMsgCompose.compFields.otherRandomHeaders += newH;	
		}
		else
			gMsgCompose.compFields.setHeader("X-Strip_Attachments", "true");
	},

	sendListener : {
		onStartSending : function(id,size) {},
		onProgress : function(aMsgID,aProgress,aProgressMax) {},
		onStatus: function	(MsgID,aMsg) {},
		onStopSending: function	(aMsgID,aStatus,aMsg,aReturnFile) {
			gStripAttachments.folderListener.id = aMsgID.replace("<","").replace(">","");
		},
		onGetDraftFolderURI: function (aFolderURI) {
			gStripAttachments.folderListener.targetURI = aFolderURI;
		},
		onSendNotPerformed :function(aMsgID,aStatus) {}
	},
	
	folderListener : {
		OnItemAdded: function(parent, item, viewString) {
			if (gStripAttachments.folderListener.abort) 
				return;
			var aMsgHdr = item.QueryInterface(Components.interfaces.nsIMsgDBHdr);
			var folderUri = aMsgHdr.folder.URI;
			if (folderUri != gStripAttachments.folderListener.targetURI)			
				return;
			if (gStripAttachments.folderListener.id && aMsgHdr.messageId == gStripAttachments.folderListener.id) {
				MsgHdrToMimeMessage(aMsgHdr, null, function(aMsgHdr, aMsg) {
					var strip = false;
					for (var h in aMsg.headers) {                               
						if (h.toLowerCase().indexOf( "x-strip_attachments") > -1) {
							strip = true;
							break;
						}
					}
					if (! strip)
						return;	
					var attachments = aMsg.allAttachments.filter(function (x) x.isRealAttachment);
					var a1 = [];
					var a2 = [];
					var a3 = [];
					var a4 = [];
					var uri = aMsgHdr.folder.getUriForMsg(aMsgHdr);
					var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance(Components.interfaces.nsIMessenger);
					for (var i=0;i<attachments.length;i++) {
						var att=attachments[i];
						if (att.contentType != "text/x-moz-deleted") {
							a1.push(att.contentType);
							a2.push(att.url);	
							a3.push(encodeURIComponent(att.name));
							a4.push(uri);						
						}
					}
					if (a1.length > 0)
						messenger.detachAllAttachments(attachments.length, a1,a2,a3,a4,false,true);
				},true);
			}
		},
		OnItemRemoved: function(parent, item, viewString) {},
		OnItemPropertyChanged: function(parent, item, viewString) {},
		OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
		OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
		OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue) {},
		OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
		OnItemEvent: function(item, event) {},
		OnFolderLoaded: function(aFolder) {},
		OnDeleteOrMoveMessagesCompleted: function( aFolder) {}
	}
};

window.addEventListener("load", gStripAttachments.init, false);

